package io.zipcoder.casino;

import java.util.ArrayList;
import java.util.Arrays;


public class BlackJack {


    private ArrayList<Card> playerHand = new ArrayList<Card>();
    private ArrayList<Card> dealerHand = new ArrayList<Card>();
    private int currentBet;
    private boolean playingBJ = false;
    private boolean playingHands = true;
    private boolean askToPlayAgain = false;
    private CardDeck deck = new CardDeck();
    private static Player player;
    static String name;
    static String choice;

    public BlackJack() {
        this.player = new Player("Eugene");
    }

    public void start() {
        playingBJ = true;
        this.deck.shuffle();
    }

    private void dealToPlayerHand(int amountOfCards) {
        for (int i = 0; i < amountOfCards; i++) {
            this.playerHand.add(deck.draw());
        }
    }

    private void dealToDealerHand(int amountOfCards) {
        for (int i = 0; i < amountOfCards; i++) {
            this.dealerHand.add(deck.draw());
        }
    }

    private void setPlayingHands(boolean bool) {
        this.playingHands = bool;
    }

    private String getPlayerHand() {
        return Arrays.toString(this.playerHand.toArray());
    }

    private String getDealerHand() {
        return Arrays.toString(this.dealerHand.toArray());
    }

    private String showDealerHand() {
        Card[] filteredArray = this.dealerHand.toArray(new Card[this.dealerHand.size()]);
        filteredArray[0] = new Card();
        return Arrays.toString(filteredArray);
    }


    private int getCurrentBet() {
        return this.currentBet;
    }

    private void setCurrentBet(int bet) {
        this.currentBet = bet;
    }

    private void setAskToPlayAgain(boolean bool) {
        this.askToPlayAgain = bool;
    }

    private void resetHands() {
        this.playerHand = new ArrayList<Card>();
        this.dealerHand = new ArrayList<Card>();
    }

    private void startHands() {
        this.deck = new CardDeck();
        this.deck.shuffle();
        resetHands();
        dealToPlayerHand(2);
        dealToDealerHand(1);
    }

    private void startNextHand() {
        setCurrentBet(0);
        setAskToPlayAgain(true);
        setPlayingHands(false);
    }

    private int getCardValue(Card card) {
        Rank rank = card.getRank();
        int calcValue = 0;
        switch (rank) {
            case ACE:
                calcValue = 11;
                break;
            case TWO:
                calcValue = 2;
                break;
            case THREE:
                calcValue = 3;
                break;
            case FOUR:
                calcValue = 4;
                break;
            case FIVE:
                calcValue = 5;
                break;
            case SIX:
                calcValue = 6;
                break;
            case SEVEN:
                calcValue = 7;
                break;
            case EIGHT:
                calcValue = 8;
                break;
            case NINE:
                calcValue = 9;
                break;
            case TEN:
                calcValue = 10;
                break;
            case JACK:
            case QUEEN:
            case KING:
                calcValue = 10;
                break;
        }
        return calcValue;
    }

    private int calcHand(ArrayList<Card> hand) {
        int totalScore = 0;
        for (int i = 0; i < hand.size(); i++) {
            totalScore += getCardValue(hand.get(i));
        }
        return totalScore;
    }

    public void startGame() {
        start();
        Console.output("Starting BlackJack...");
        while (playingBJ) {
            while (askToPlayAgain) {
                String answer = Console.askForInput("Would you like to play again? (Y/N)");
                if (answer.equals("y")) {
                    setPlayingHands(true);
                    setAskToPlayAgain(false);
                } else {
                    setPlayingHands(false);
                    setAskToPlayAgain(false);
                }
            }
            while (playingHands) {
                int bet = Console.numberFromString(Console.askForInput("Starting bet amount: "));
                setCurrentBet(bet);
                startHands();

                Console.output("You have: " + getPlayerHand() + " for a total of " + calcHand(playerHand));
                Console.output("Dealer is showing: " + getDealerHand());
                boolean dStay = true;
                boolean pStay = false;
                while ((calcHand(playerHand) < 21 && calcHand(dealerHand) < 21) && pStay == false) {
                    String action = Console.askForInput("Hit or Stay? (H/S)");
                    if (action.equals("h")) {
                        dealToPlayerHand(1);
                        Console.output("You now have:\n" + getPlayerHand() + " for a total of " + calcHand(playerHand));
                        if (calcHand(playerHand) > 21) {
                            Console.output("Dealer wins! You bust.");
                            pStay = true;
                            startNextHand();
                        }
                    }
                    if (action.equals("s")) {
                        dealToDealerHand(1);
                        pStay = true;
                        dStay = false;
                    }
                }
                Console.output("Dealer has: " + getDealerHand() + " for a total of " + calcHand(dealerHand));
                while (dStay == false) {
                    if (calcHand(dealerHand) > 21) {
                        Console.output("Dealer busts! You win");
                        startNextHand();
                        dStay = true;
                    }
                    if (calcHand(dealerHand) < 17) {
                        dealToDealerHand(1);
                        Console.output("Dealer hits.");
                        Console.output("Dealer has: " + getDealerHand() + " for a total of " + calcHand(dealerHand));

                    } else if (calcHand(dealerHand) >= 17 && calcHand(dealerHand) <= 21) {
                        Console.output("Dealer stays.");
                        dStay = true;
                    }
                }
                if (calcHand(dealerHand) == 21) {
                    Console.output("Dealer has BlackJack! You lose!");
                    player.subtractFromBankroll(currentBet);
                    startNextHand();
                } else if (calcHand(playerHand) == 21) {
                    Console.output("You have BlackJack! You win!");
                    player.addToBankroll((currentBet * 3) / 2);
                    startNextHand();
                } else if (calcHand(playerHand) == calcHand(dealerHand)) {
                    Console.output("It's a tie!");
                    startNextHand();
                } else if ((calcHand(playerHand) < 22) && (calcHand(playerHand) > calcHand(dealerHand))) {
                    Console.output("You win!");
                } else if ((calcHand(dealerHand) < 22) && (calcHand(dealerHand) > calcHand(playerHand))) {
                    Console.output("You lose!");
                }
                startNextHand();

            }
        }
    }
}





